Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90	(revision 8486)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE  iceforcing  ***
-   !! call surface forcing for sea ice model
+   !! Sea-Ice :   air-ice forcing fields
    !!=====================================================================
    !! History :  4.0  ! 2017-08  (C. Rousset) Original code
@@ -10,21 +10,20 @@
    !!   'key_lim3' :                                  LIM 3.0 sea-ice model
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE ice             ! LIM-3: ice variables
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE ice            ! sea-ice variables
+   USE sbc_oce        ! Surface boundary condition: ocean fields
+   USE sbc_ice        ! Surface boundary condition: ice   fields
+   USE usrdef_sbc     ! user defined: surface boundary condition
+   USE sbcblk         ! Surface boundary condition: bulk
+   USE sbccpl         ! Surface boundary condition: coupled interface
+   USE icealb         ! ice albedo
    !
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_ice         ! Surface boundary condition: ice   fields
-   USE usrdef_sbc      ! user defined: surface boundary condition
-   USE sbcblk          ! Surface boundary condition: bulk
-   USE sbccpl          ! Surface boundary condition: coupled interface
-   USE icealb          ! ice albedo
-   !
-   USE iom             ! I/O manager library
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! lateral boundary condition - MPP link
-   USE lib_mpp         ! MPP library
-   USE lib_fortran     !
-   USE timing          ! Timing
+   USE iom            ! I/O manager library
+   USE in_out_manager ! I/O manager
+   USE lbclnk         ! lateral boundary condition - MPP link
+   USE lib_mpp        ! MPP library
+   USE lib_fortran    !
+   USE timing         ! Timing
 
    IMPLICIT NONE
@@ -37,5 +36,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 4.0 , UCL NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , UCL NEMO Consortium (2017)
    !! $Id: icestp.F90 8319 2017-07-11 15:00:44Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -113,13 +112,12 @@
       !!                alb_ice                                  = albedo above sea ice
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt      ! ocean time step
-      INTEGER, INTENT(in) ::   ksbc    ! type of sbc flux ( 1 = user defined formulation, 
-                                       !                    3 = bulk formulation,
-                                       !                    4 = Pure Coupled formulation)
+      INTEGER, INTENT(in) ::   kt     ! ocean time step
+      INTEGER, INTENT(in) ::   ksbc   ! flux formulation (user defined, bulk or Pure Coupled)
+      !
       INTEGER  ::   ji, jj, jl                                ! dummy loop index
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zalb_os, zalb_cs  ! ice albedo under overcast/clear sky
       REAL(wp), DIMENSION(jpi,jpj)     ::   zalb              ! 2D workspace
       !!----------------------------------------------------------------------
-
+      !
       IF( nn_timing == 1 )   CALL timing_start('ice_forcing_flx')
 
@@ -136,5 +134,6 @@
       DO jl = 1, jpl
          DO jj = 2, jpjm1
-            DO ji = 2, jpim1                                
+            DO ji = 2, jpim1
+!!gm cldf_ice is a real, DOCTOR naming rule: start with cd means CHARACTER passed in argument !
                alb_ice(ji,jj,jl) = ( 1. - cldf_ice ) * zalb_cs(ji,jj,jl) + cldf_ice * zalb_os(ji,jj,jl)
             END DO
@@ -143,31 +142,34 @@
       CALL lbc_lnk( alb_ice, 'T', 1. )
       
-      ! --- fluxes over sea ice --- !
-      SELECT CASE( ksbc )
-         CASE( jp_usr )                                          ! user defined formulation
-                                   CALL usrdef_sbc_ice_flx( kt )
-
-         CASE( jp_blk )                                          ! bulk formulation
-                                   CALL blk_ice_flx( t_su, alb_ice )
-            IF( ln_mixcpl      )   CALL sbc_cpl_ice_flx( picefr=at_i_b, palbi=alb_ice, psst=sst_m, pist=t_su )
-            IF( nn_limflx /= 2 )   CALL ice_flx_dist( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
-
-         CASE ( jp_purecpl )                                     ! coupled formulation
-                                   CALL sbc_cpl_ice_flx( picefr=at_i_b, palbi=alb_ice, psst=sst_m, pist=t_su )
-            IF( nn_limflx == 2 )   CALL ice_flx_dist( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
-      END SELECT
-
-      ! --- albedo output --- !
-      WHERE( at_i_b <= epsi06 )  ;  zalb(:,:) = rn_alb_oce
-      ELSEWHERE                  ;  zalb(:,:) = SUM( alb_ice * a_i_b, dim=3 ) / at_i_b
-      END WHERE
-      IF( iom_use('icealb'  ) )  CALL iom_put( "icealb" , zalb(:,:) )   ! ice albedo
-
-      zalb(:,:) = SUM( alb_ice * a_i_b, dim=3 ) + rn_alb_oce * ( 1._wp - at_i_b )
-      IF( iom_use('albedo'  ) )  CALL iom_put( "albedo" , zalb(:,:) )   ! surface albedo
-      !
+      SELECT CASE( ksbc )      !==  fluxes over sea ice  ==!
+      !
+      CASE( jp_usr )                !--- user defined formulation
+                                CALL usrdef_sbc_ice_flx( kt )
+         !
+      CASE( jp_blk )                !--- bulk formulation
+                                CALL blk_ice_flx( t_su, alb_ice )    ! 
+         IF( ln_mixcpl      )   CALL sbc_cpl_ice_flx( picefr=at_i_b, palbi=alb_ice, psst=sst_m, pist=t_su )
+         IF( nn_limflx /= 2 )   CALL ice_flx_dist( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+         !
+      CASE ( jp_purecpl )           !--- coupled formulation
+                                CALL sbc_cpl_ice_flx( picefr=at_i_b, palbi=alb_ice, psst=sst_m, pist=t_su )
+         IF( nn_limflx == 2 )   CALL ice_flx_dist( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+         !
+      END SELECT
+
+      IF( iom_use('icealb') ) THEN    !--- output ice albedo
+         WHERE( at_i_b <= epsi06 )   ;   zalb(:,:) = rn_alb_oce
+         ELSEWHERE                   ;   zalb(:,:) = SUM( alb_ice * a_i_b, dim=3 ) / at_i_b
+         END WHERE
+         CALL iom_put( "icealb" , zalb(:,:) )   ! ice albedo
+      ENDIF
+
+      IF( iom_use('albedo') ) THEN  !--- surface albedo
+         zalb(:,:) = SUM( alb_ice * a_i_b, dim=3 ) + rn_alb_oce * ( 1._wp - at_i_b )
+         CALL iom_put( "albedo" , zalb(:,:) )
+      ENDIF
       !
       IF( nn_timing == 1 )   CALL timing_stop('ice_forcing_flx')
-
+      !
    END SUBROUTINE ice_forcing_flx
 
@@ -177,6 +179,6 @@
       !!                  ***  ROUTINE ice_flx_dist  ***
       !!
-      !! ** Purpose :   update the ice surface boundary condition by averaging and / or
-      !!                redistributing fluxes on ice categories
+      !! ** Purpose :   update the ice surface boundary condition by averaging 
+      !!              and/or redistributing fluxes on ice categories
       !!
       !! ** Method  :   average then redistribute
@@ -208,30 +210,40 @@
       IF( nn_timing == 1 )  CALL timing_start('ice_flx_dist')
       !
-      SELECT CASE( k_limflx )                              !==  averaged on all ice categories  ==!
+      SELECT CASE( k_limflx )       !==  averaged on all ice categories  ==!
+      !
       CASE( 0 , 1 )
-         !
-         z_qns_m  (:,:) = fice_ice_ave ( pqns_ice (:,:,:) )
-         z_qsr_m  (:,:) = fice_ice_ave ( pqsr_ice (:,:,:) )
-         z_dqn_m  (:,:) = fice_ice_ave ( pdqn_ice (:,:,:) )
-         z_evap_m (:,:) = fice_ice_ave ( pevap_ice (:,:,:) )
-         z_devap_m(:,:) = fice_ice_ave ( pdevap_ice (:,:,:) )
+         z_qns_m  (:,:) = fice_ice_ave( pqns_ice  (:,:,:) )
+         z_qsr_m  (:,:) = fice_ice_ave( pqsr_ice  (:,:,:) )
+         z_dqn_m  (:,:) = fice_ice_ave( pdqn_ice  (:,:,:) )
+         z_evap_m (:,:) = fice_ice_ave( pevap_ice (:,:,:) )
+         z_devap_m(:,:) = fice_ice_ave( pdevap_ice(:,:,:) )
+!!gm faster coding
+!    REAL(wp), DIMENSION(jpi,jpj) ::   z1_at_i   ! 
+! ...
+!      WHERE ( at_i (:,:) > 0._wp )   ; z1_at_i(:,:) = 1._wp / at_i (:,:)
+!      ELSEWHERE                      ; z1_at_i(:,:) = 0._wp
+!      END WHERE
+!      z_qns_m  (:,:) = SUM( a_i(:,:,:) * pqns_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
+!      z_qsr_m  (:,:) = SUM( a_i(:,:,:) * pqsr_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
+!      z_dqn_m  (:,:) = SUM( a_i(:,:,:) * pdqn_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
+!      z_evap_m (:,:) = SUM( a_i(:,:,:) * pevap_ice (:,:,:) , dim=3 ) * z1_at_i(:,:)
+!      z_devap_m(:,:) = SUM( a_i(:,:,:) * pdevap_ice(:,:,:) , dim=3 ) * z1_at_i(:,:)
+!! and remove the 2 functions: fice_ice_ave and fice_cell_ave
+!!gm
          DO jl = 1, jpl
-            pdqn_ice  (:,:,jl) = z_dqn_m(:,:)
+            pdqn_ice  (:,:,jl) = z_dqn_m  (:,:)
             pdevap_ice(:,:,jl) = z_devap_m(:,:)
-         END DO
-         !
-         DO jl = 1, jpl
-            pqns_ice (:,:,jl) = z_qns_m(:,:)
-            pqsr_ice (:,:,jl) = z_qsr_m(:,:)
-            pevap_ice(:,:,jl) = z_evap_m(:,:)
-         END DO
-         !
-      END SELECT
-      !
-      SELECT CASE( k_limflx )                              !==  redistribution on all ice categories  ==!
+            pqns_ice  (:,:,jl) = z_qns_m (:,:)
+            pqsr_ice  (:,:,jl) = z_qsr_m (:,:)
+            pevap_ice (:,:,jl) = z_evap_m(:,:)
+         END DO
+         !
+      END SELECT
+      !
+      SELECT CASE( k_limflx )       !==  redistribution on all ice categories  ==!
       CASE( 1 , 2 )
          !
-         zalb_m(:,:) = fice_ice_ave ( palb_ice (:,:,:) )
-         ztem_m(:,:) = fice_ice_ave ( ptn_ice  (:,:,:) )
+         zalb_m(:,:) = fice_ice_ave( palb_ice(:,:,:) )
+         ztem_m(:,:) = fice_ice_ave( ptn_ice (:,:,:) )
          DO jl = 1, jpl
             pqns_ice (:,:,jl) = pqns_ice (:,:,jl) + pdqn_ice  (:,:,jl) * ( ptn_ice(:,:,jl) - ztem_m(:,:) )
@@ -246,19 +258,17 @@
    END SUBROUTINE ice_flx_dist
 
-
+!!gm TO BE REMOVED ====>>>>>
    FUNCTION fice_cell_ave ( ptab )
       !!--------------------------------------------------------------------------
       !! * Compute average over categories, for grid cell (ice covered and free ocean)
       !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj) :: fice_cell_ave
-      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT (in) :: ptab
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(in) :: ptab
+      REAL(wp), DIMENSION(jpi,jpj)                 :: fice_cell_ave
       INTEGER :: jl
       !!--------------------------------------------------------------------------
-
-      fice_cell_ave (:,:) = 0._wp
-      DO jl = 1, jpl
-         fice_cell_ave (:,:) = fice_cell_ave (:,:) + a_i (:,:,jl) * ptab (:,:,jl)
+      fice_cell_ave(:,:) = a_i(:,:,1) * ptab (:,:,1)
+      DO jl = 2, jpl
+         fice_cell_ave(:,:) = fice_cell_ave(:,:) + a_i(:,:,jl) * ptab (:,:,jl)
       END DO
-
    END FUNCTION fice_cell_ave
 
@@ -268,14 +278,18 @@
       !! * Compute average over categories, for ice covered part of grid cell
       !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj) :: fice_ice_ave
-      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(in) :: ptab
-     !!--------------------------------------------------------------------------
-
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(in) ::   ptab   !
+      REAL(wp), DIMENSION(jpi,jpj)                 :: fice_ice_ave
+      !!--------------------------------------------------------------------------
       WHERE ( at_i (:,:) > 0.0_wp ) ; fice_ice_ave (:,:) = fice_cell_ave( ptab (:,:,:) ) / at_i (:,:)
       ELSEWHERE                     ; fice_ice_ave (:,:) = 0.0_wp
       END WHERE
-      
    END FUNCTION fice_ice_ave
 
+!!gm <<<<<<====  end of TO BE REMOVED 
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option :         Empty module          NO LIM sea-ice model
+   !!----------------------------------------------------------------------
 #endif
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90	(revision 8486)
@@ -5,13 +5,15 @@
    !!======================================================================
    !! History :  2.0  ! 2004-01 (C. Ethe, G. Madec)  Original code
-   !!            3.0  ! 2011-02 (G. Madec) dynamical allocation
-   !!             -   ! 2014    (C. Rousset) add N/S initializations
+   !!            3.0  ! 2007    (M. Vancoppenolle)  Rewrite for ice cats
+   !!            3.0  ! 2009-11 (M. Vancoppenolle)  Enhanced version for ice cats
+   !!            3.0  ! 2011-02 (G. Madec)  dynamical allocation
+   !!             -   ! 2014    (C. Rousset)  add N/S initializations
    !!----------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                    LIM3 sea-ice model
-   !!----------------------------------------------------------------------
-   !!   ice_ist      :  Initialisation of diagnostics ice variables
-   !!   ice_ist_init :  initialization of ice state and namelist read
+   !!   'key_lim3'                                       LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   ice_ist       :  initialization of diagnostics ice variables
+   !!   ice_ist_init  :  initialization of ice state and namelist read
    !!----------------------------------------------------------------------
    USE phycst         ! physical constant
@@ -34,5 +36,5 @@
    PRIVATE
 
-   PUBLIC   ice_ist      ! routine called by lim_init.F90
+   PUBLIC   ice_ist      ! called by icestp.F90
 
    INTEGER , PARAMETER ::   jpfldi = 6           ! maximum number of files to read
@@ -45,5 +47,5 @@
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   si  ! structure of input fields (file informations, fields read)
    !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-LOCEAN-IPSL (2008)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: iceist.F90 8378 2017-07-26 13:55:59Z clem $
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -51,4 +53,5 @@
 CONTAINS
 
+!!gm  better name:  ice_istate
    SUBROUTINE ice_ist
       !!-------------------------------------------------------------------
@@ -71,11 +74,5 @@
       !! ** Notes   : o_i, t_su, t_s, t_i, s_i must be filled everywhere, even
       !!              where there is no ice (clem: I do not know why, is it mandatory?) 
-      !!
-      !! History :
-      !!   2.0  !  01-04  (C. Ethe, G. Madec)  Original code
-      !!   3.0  !  2007   (M. Vancoppenolle)   Rewrite for ice cats
-      !!   4.0  !  09-11  (M. Vancoppenolle)   Enhanced version for ice cats
       !!--------------------------------------------------------------------
-      !! * Local variables
       INTEGER    :: ji, jj, jk, jl             ! dummy loop indices
       REAL(wp)   :: ztmelts, zdh
@@ -591,7 +588,4 @@
    !!   Default option :         Empty module          NO LIM sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_ist          ! Empty routine
-   END SUBROUTINE ice_ist
 #endif
 
